<?php
/********************************************************************
Product		: Flexicontact
Date		: 24 July 2017
Copyright	: Les Arbres Design 2010-2017
Contact		: http://www.lesarbresdesign.info
Licence		: GNU General Public License
*********************************************************************/
defined('_JEXEC') or die('Restricted Access');

class FlexicontactViewImages extends JViewLegacy
{
function display($tpl = null)
{
	Flexicontact_Utility::viewStart();
	JToolBarHelper::title(LAFC_COMPONENT_NAME.': '.JText::_('COM_FLEXICONTACT_CAPTCHA_IMAGES'), 'flexicontact.png');
	JToolBarHelper::deleteList('','delete_image');
	JToolBarHelper::cancel();
        
// find out where the images are        
        
    $image_path_info = Flexicontact_Utility::get_captcha_image_path();
    $image_path = $image_path_info['path'];
    $image_url = $image_path_info['url'];
    FC_trace::trace("Image path is $image_path");
        
// Make the list of old (hard coded) themes

    $theme_info_array['all']['list_name'] = JText::_('JALL');
    $theme_info_array['all']['regex'] = '.*';
    $theme_info_array['standard']['list_name'] = 'Standard';
    $theme_info_array['standard']['regex'] = '^\d*.gif$';
    $theme_info_array['toys']['list_name'] = 'Toys';
    $theme_info_array['toys']['regex'] = '^[AB]_\d*.gif$';
    $theme_info_array['neon']['list_name'] = 'Neon';
    $theme_info_array['neon']['regex'] = '^C_\d*.png$';
    $theme_info_array['white']['list_name'] = 'White Tiles';
    $theme_info_array['white']['regex'] = '^D_\d*.png$';
    $theme_info_array['black']['list_name'] = 'Black Tiles';
    $theme_info_array['black']['regex'] = '^E_\d*.png$';
    
// search for any new themes (defined by an XML file)

    if (is_dir(JPATH_SITE.'/media/com_flexicontact/images'))
        {
        $xml_files = glob(JPATH_SITE.'/media/com_flexicontact/*.xml');
        foreach ($xml_files as $xml_file)
            {
            FC_trace::trace("Loading theme from $xml_file");
            $xml = JFactory::getXML($xml_file,true);
            if (!isset($xml->theme_info))
                continue;
            $short_name = (string) $xml->theme_info->short_name;
            $theme_info_array[$short_name] = array();
       		$theme_info_array[$short_name]['list_name'] = (string) $xml->theme_info->list_name;
       		$theme_info_array[$short_name]['regex'] = (string) $xml->theme_info->regex;
       		$theme_info_array[$short_name]['extension_name'] = strtolower($xml->name);
            }
        }
        
// make the theme select list, only including themes for which we actually have some images

    $theme_list = array();
    foreach ($theme_info_array as $short_name => $theme_info)
        {
        $imageFiles = self::get_image_files($image_path, $theme_info['regex']);
        if (count($imageFiles) > 0)
            $theme_list[$short_name] = $theme_info['list_name'];
        }
	$app = JFactory::getApplication();
	$filter_theme = $app->getUserStateFromRequest(LAFC_COMPONENT.'.filter_theme','filter_theme', 'all','word');
    if (!array_key_exists($filter_theme, $theme_list))
        $filter_theme = 'all';
    $theme_list_html = Flexicontact_Utility::make_list('filter_theme', $filter_theme, $theme_list, 0, 'onchange="submitform();"');
	
// load the additional language file provided by our old image packs, if it is present
// if not, load the front end Flexicontact language file for the current language (it has names for the default images)

	$lang = JFactory::getLanguage();
	$language = $lang->get('tag');
	if (file_exists(JPATH_SITE.'/language/'.$language.'/'.$language.'.com_flexicontact_captcha.ini'))
        {
        FC_trace::trace("Loading language file: ".JPATH_SITE.'/language/'.$language.'/'.$language.'.com_flexicontact_captcha.ini');
		$lang->load('com_flexicontact_captcha', JPATH_SITE);
        }
	else
        {
        FC_trace::trace("Loading language file: ".JPATH_SITE.'/language/components/com_flexicontact/'.$language.'/'.$language.'.com_flexicontact.ini');
		$lang->load('com_flexicontact', JPATH_SITE.'/components/com_flexicontact');
        }
        
// load any additional language files provided by new xml image packs

    $lang_files = glob(JPATH_SITE.'/components/com_flexicontact/language/'.$language.'/'.$language.'.com_flexicontact_theme_*.ini');
    foreach ($lang_files as $lang_file)
        {
        FC_trace::trace("Loading language file: $lang_file");
        $base_name = basename($lang_file);
        $file_name = substr($base_name,6,(strlen($base_name)-10));
    	$lang->load($file_name, JPATH_SITE.'/components/com_flexicontact');
        }
    
// get an array of all the filenames in the image directory

    $imageFiles = self::get_image_files($image_path, $theme_info_array[$filter_theme]['regex']);
    
    if ($imageFiles === false)
		{
		echo JText::_('COM_FLEXICONTACT_NO_IMAGES_DIRECTORY');
		return;
		}
    
    $image_count = count($imageFiles);
	sort($imageFiles);

// start the form

	echo '<form action="index.php" method="post" name="adminForm" id="adminForm" >';
	echo '<input type="hidden" name="option" value="com_flexicontact" />';
	echo '<input type="hidden" name="controller" value="menu" />';
	echo '<input type="hidden" name="task" value="images" />';
	echo '<input type="hidden" name="boxchecked" value="0" />';
	
// filter header
    
	echo "\n".'<div>&nbsp;<div style="float:left;">';
    echo JText::_('JGLOBAL_CHECK_ALL');
	echo ' <input type="checkbox" name="toggle" value="" style="vertical-align:baseline;" onclick="Joomla.checkAll(this);" /> ';
    echo $image_count.' '.JText::_('COM_FLEXICONTACT_IMAGES');
	echo '</div>';
	echo "\n".'<div style="float:right">';
    echo $image_path.' ';
    echo $theme_list_html;
	echo ' <button class="btn btn-primary" onclick="'."
			this.form.filter_theme.value='all';
			this.form.submit();".'">'.JText::_('JSEARCH_RESET').'</button>';
	echo '</div></div>';
    echo '<div style="margin-top:10px;">&nbsp;</div>';

    if (empty($imageFiles) and $filter_theme == 'all')
		{
		echo JText::_('COM_FLEXICONTACT_NO_IMAGES');
        echo '</form>';
        Flexicontact_Utility::viewEnd();
        return;
		}
	
	$i = 0;
	foreach ($imageFiles as $filename)
		{
		$imageInfo = getimagesize($image_path.'/'.$filename);
		if ($imageInfo !== false)
			{
			$imageX = $imageInfo[0];
			$imageY = $imageInfo[1];
			}
		
		$text_name = 'COM_FLEXICONTACT_IMAGE_'.strtoupper($filename);
		$description = JText::_($text_name);	// resolved by front end language file
		if ($text_name == $description)			// highlight if not resolved
			$description = '<span style="color:red">'.$description.'</span>';
		
		echo "\n".'<div class="fcc_image_cell">';
		echo "\n".'<img src="'.$image_url.$filename.'" width="100" alt="" />';
		echo "\n".'<b>'.utf8_encode($filename).'</b><br />';
		echo $description.'<br />';
		echo $imageX.'x'.$imageY.'<br />';
		echo "\n".JHTML::_('grid.id',   $i++, $filename);
		echo '</div>';
		}

	echo '</form>';
	Flexicontact_Utility::viewEnd();
}

// -------------------------------------------------------------------------------
// get an array of image files matching a regular expression (glob() can't do this)
//
static function get_image_files($image_path, $regex)
{
    if (!is_dir($image_path))
        return false;
    $handle = opendir($image_path);
	if (!$handle)
		return false;

    $files = array();
    $regex = '/'.$regex.'/';
	while (($filename = readdir($handle)) != false)
		{
        if ($filename == '.' or $filename == '..')
            continue;
        if (preg_match($regex, $filename) != 1)
            continue;
        $imageInfo = @getimagesize($image_path.'/'.$filename);
        if ($imageInfo === false)
            continue;					// not an image
        if ($imageInfo[3] > 3)			// we only support gif, jpg or png
            continue;
        if ($imageInfo[0] > 150)		// if X size > 150 pixels ..
            continue;					// .. it's too big so skip it
        $files[] = $filename;
   		}
    closedir($handle);
    return $files;
}

}